# Copyright 2020 Dezmo
module Dezmo
module Dezmo_Save_as_DC_name
  extend self
  @@loaded = false unless defined?(@@loaded)
  
  def get_dc_name
    mod = Sketchup.active_model
    sel = mod.selection
    if sel.single_object? && sel.first.respond_to?(:definition)
      name = sel.first.definition.get_attribute("dynamic_attributes", "name")
      def_name = sel.first.definition.name
      inst_name = sel.first.name
      return [sel.first.definition, mod.path, name, def_name, inst_name]
    else
      return [nil]
    end
  end

  def dc_save_as(param, n = 2)
    definition = param[0] 
    path = param[1]
    name = param[n]
    path_name = UI.savepanel("Save DC", path, "#{name}.skp")
    definition.save_as path_name if path_name
  end
  
  unless @@loaded
    UI.add_context_menu_handler do |context_menu|
      sub_menu = context_menu.add_submenu("Save As.. *name: ") if get_dc_name.length>1
      if get_dc_name[2] && sub_menu
        sub_menu.add_item("DC name: #{get_dc_name[2]}"){
          dc_save_as(get_dc_name,2)
        } 
      end
      if get_dc_name[3] && sub_menu
        sub_menu.add_item("Def name: #{get_dc_name[3]}"){
          dc_save_as(get_dc_name,3)
        } 
      end
      if get_dc_name[4] && get_dc_name[4] != "" && sub_menu
        sub_menu.add_item("Inst name: #{get_dc_name[4]}"){
          dc_save_as(get_dc_name,4)
        } 
      end
    end
    @@loaded = true
  end
end
end